<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Adding and Removing Entries</TITLE>
<link href="suif1_50.html" rel=Next>
<link href="suif1_48.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_48.html">previous</A>, <A HREF="suif1_50.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC49" HREF="suif1_toc.html#TOC49">Adding and Removing Entries</A></H2>
<P>
<A NAME="IDX309"></A>
<A NAME="IDX310"></A>

</P>
<P>
Entries in symbol tables should always be added and removed using the
methods provided by the symbol tables.  Although it is possible to add
and remove entries by directly manipulating the lists, that should never
be done.  The methods for adding and removing entries hide the
underlying representation and using them will make it much easier to
update your code if that representation changes.  Even more importantly,
most symbol table entries contain back pointers to the tables which hold
them, and the adding and removing methods are responsible for
maintaining those pointers and for performing a few other automatic
checks and updates.

</P>
<P>
<A NAME="IDX311"></A>
<A NAME="IDX312"></A>
<A NAME="IDX313"></A>
<A NAME="IDX314"></A>
<A NAME="IDX315"></A>
<A NAME="IDX316"></A>
Types, symbols, and child symbol tables may be added using the
<CODE>add_type</CODE>, <CODE>add_sym</CODE>, and <CODE>add_child</CODE> methods,
respectively.  Each of these entries contains a pointer back to the
parent symbol table, and these methods automatically set those back
pointers.  They do not, however, perform any other sanity checks, such
as checking for duplicate names.  Similarly, the <CODE>remove_type</CODE>,
<CODE>remove_sym</CODE>, and <CODE>remove_child</CODE> methods remove types,
symbols, and child symbol table entries.  These methods clear the parent
pointers but do not delete the entries that are removed.

</P>
<P>
<A NAME="IDX317"></A>
<A NAME="IDX318"></A>
Variable definitions are treated a bit differently from other kinds of
symbol table entries.  They do not have parent pointers so the
<CODE>add_def</CODE> and <CODE>remove_def</CODE> methods do not have to deal with
that.  However, adding and removing variable definitions change some
attributes of the corresponding variables, and those attributes must be
automatically updated.  First, each variable has a flag to indicate
whether a variable definition exists for it.  A variable cannot have
more than one definition, so the <CODE>add_def</CODE> method will fail if this
flag is already set.  Otherwise, it sets the flag when the new
definition is added.  Second, variable symbols also have a flag to
indicate whether they are actual definitions or just declarations of
symbols with external linkage.  This <CODE>extern</CODE> flag must be set to
<CODE>FALSE</CODE> when a variable definition is added for a global variable.
When removing a variable definition, these flags must be reversed.

</P>
<P>
<A NAME="IDX319"></A>
Unlike symbol nodes which always define separate symbols, multiple type
nodes can represent the same type.  The basic <CODE>add_type</CODE> method
will add a new type even if an equivalent type was already defined in
the same scope.  In most cases, what is actually needed is a method to
first check if an equivalent type exists and if so to throw away the
duplicate and return the existing type.  The <CODE>install_type</CODE> method
provides this functionality.  It first checks if a type has already been
entered in the symbol table or one of its ancestors using the
<CODE>lookup_type</CODE> method.  If so, it deletes the new type and returns
the existing one.  If a type is not found, it is entered into the symbol
table and returned.  All of the components of a type are recursively
installed before the type itself.  This makes it easy to create new
types without worrying about duplicate entries in the symbol tables.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_48.html">previous</A>, <A HREF="suif1_50.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
